Index: kernel/generic/src/ipc/event.c
===================================================================
--- kernel/generic/src/ipc/event.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/event.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -138,8 +138,8 @@
 }
 
-static errno_t event_enqueue(event_t *event, bool mask, sysarg_t a1, sysarg_t a2,
+static int event_enqueue(event_t *event, bool mask, sysarg_t a1, sysarg_t a2,
     sysarg_t a3, sysarg_t a4, sysarg_t a5)
 {
-	errno_t res;
+	int res;
 
 	spinlock_lock(&event->lock);
@@ -206,5 +206,5 @@
  *
  */
-errno_t event_notify(event_type_t evno, bool mask, sysarg_t a1, sysarg_t a2,
+int event_notify(event_type_t evno, bool mask, sysarg_t a1, sysarg_t a2,
     sysarg_t a3, sysarg_t a4, sysarg_t a5)
 {
@@ -234,5 +234,5 @@
  *
  */
-errno_t event_task_notify(task_t *task, event_task_type_t evno, bool mask,
+int event_task_notify(task_t *task, event_task_type_t evno, bool mask,
     sysarg_t a1, sysarg_t a2, sysarg_t a3, sysarg_t a4, sysarg_t a5)
 {
@@ -255,8 +255,8 @@
  *
  */
-static errno_t event_subscribe(event_t *event, sysarg_t imethod,
+static int event_subscribe(event_t *event, sysarg_t imethod,
     answerbox_t *answerbox)
 {
-	errno_t res;
+	int res;
 	
 	spinlock_lock(&event->lock);
@@ -286,7 +286,7 @@
  *
  */
-static errno_t event_unsubscribe(event_t *event, answerbox_t *answerbox)
-{
-	errno_t res;
+static int event_unsubscribe(event_t *event, answerbox_t *answerbox)
+{
+	int res;
 	
 	spinlock_lock(&event->lock);
@@ -338,10 +338,10 @@
  *
  */
-sys_errno_t sys_ipc_event_subscribe(sysarg_t evno, sysarg_t imethod)
+sysarg_t sys_ipc_event_subscribe(sysarg_t evno, sysarg_t imethod)
 {
 	if (evno >= EVENT_TASK_END)
 		return ELIMIT;
 	
-	return (sys_errno_t) event_subscribe(evno2event(evno, TASK),
+	return (sysarg_t) event_subscribe(evno2event(evno, TASK),
 	    (sysarg_t) imethod, &TASK->answerbox);
 }
@@ -357,10 +357,10 @@
  *
  */
-sys_errno_t sys_ipc_event_unsubscribe(sysarg_t evno)
+sysarg_t sys_ipc_event_unsubscribe(sysarg_t evno)
 {
 	if (evno >= EVENT_TASK_END)
 		return ELIMIT;
 	
-	return (sys_errno_t) event_unsubscribe(evno2event(evno, TASK),
+	return (sysarg_t) event_unsubscribe(evno2event(evno, TASK),
 	    &TASK->answerbox);
 }
@@ -379,5 +379,5 @@
  *
  */
-sys_errno_t sys_ipc_event_unmask(sysarg_t evno)
+sysarg_t sys_ipc_event_unmask(sysarg_t evno)
 {
 	if (evno >= EVENT_TASK_END)
Index: kernel/generic/src/ipc/ipc.c
===================================================================
--- kernel/generic/src/ipc/ipc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ipc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -205,8 +205,8 @@
  * @param request Call structure with request.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t ipc_call_sync(phone_t *phone, call_t *request)
+ * @return EOK on success or a negative error code.
+ *
+ */
+int ipc_call_sync(phone_t *phone, call_t *request)
 {
 	answerbox_t *mybox = slab_alloc(answerbox_cache, 0);
@@ -216,5 +216,5 @@
 	request->callerbox = mybox;
 	
-	errno_t rc = ipc_call(phone, request);
+	int rc = ipc_call(phone, request);
 	if (rc != EOK) {
 		slab_free(answerbox_cache, mybox);
@@ -371,5 +371,5 @@
  *
  */
-void ipc_backsend_err(phone_t *phone, call_t *call, errno_t err)
+void ipc_backsend_err(phone_t *phone, call_t *call, sysarg_t err)
 {
 	_ipc_call_actions_internal(phone, call, false);
@@ -415,5 +415,5 @@
  *
  */
-errno_t ipc_call(phone_t *phone, call_t *call)
+int ipc_call(phone_t *phone, call_t *call)
 {
 	mutex_lock(&phone->lock);
@@ -444,9 +444,9 @@
  * @param phone Phone structure to be hung up.
  *
- * @return EOK if the phone is disconnected.
- * @return EINVAL if the phone was already disconnected.
- *
- */
-errno_t ipc_phone_hangup(phone_t *phone)
+ * @return 0 if the phone is disconnected.
+ * @return -1 if the phone was already disconnected.
+ *
+ */
+int ipc_phone_hangup(phone_t *phone)
 {
 	mutex_lock(&phone->lock);
@@ -455,5 +455,5 @@
 	    phone->state == IPC_PHONE_CONNECTING) {
 		mutex_unlock(&phone->lock);
-		return EINVAL;
+		return -1;
 	}
 	
@@ -478,5 +478,5 @@
 	mutex_unlock(&phone->lock);
 	
-	return EOK;
+	return 0;
 }
 
@@ -495,5 +495,5 @@
  *
  */
-errno_t ipc_forward(call_t *call, phone_t *newphone, answerbox_t *oldbox,
+int ipc_forward(call_t *call, phone_t *newphone, answerbox_t *oldbox,
     unsigned int mode)
 {
@@ -535,9 +535,9 @@
 	uint64_t answer_cnt = 0;
 	uint64_t call_cnt = 0;
-	errno_t rc;
+	int rc;
 	
 restart:
-	rc = waitq_sleep_timeout(&box->wq, usec, flags, NULL);
-	if (rc != EOK)
+	rc = waitq_sleep_timeout(&box->wq, usec, flags);
+	if (SYNCH_FAILED(rc))
 		return NULL;
 	
@@ -638,5 +638,5 @@
 		phone = list_get_instance(list_first(&box->connected_phones),
 		    phone_t, link);
-		if (mutex_trylock(&phone->lock) != EOK) {
+		if (SYNCH_FAILED(mutex_trylock(&phone->lock))) {
 			irq_spinlock_unlock(&box->lock, true);
 			DEADLOCK_PROBE(p_phonelck, DEADLOCK_THRESHOLD);
Index: kernel/generic/src/ipc/ipcrsc.c
===================================================================
--- kernel/generic/src/ipc/ipcrsc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ipcrsc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -166,13 +166,11 @@
  * @param task  Task for which to allocate a new phone.
  *
- * @param[out] out_handle  New phone capability handle.
- *
- * @return  An error code if a new capability cannot be allocated.
- */
-errno_t phone_alloc(task_t *task, cap_handle_t *out_handle)
-{
-	cap_handle_t handle;
-	errno_t rc = cap_alloc(task, &handle);
-	if (rc == EOK) {
+ * @return  New phone capability handle.
+ * @return  Negative error code if a new capability cannot be allocated.
+ */
+cap_handle_t phone_alloc(task_t *task)
+{
+	cap_handle_t handle = cap_alloc(task);
+	if (handle >= 0) {
 		phone_t *phone = slab_alloc(phone_cache, FRAME_ATOMIC);
 		if (!phone) {
@@ -195,8 +193,7 @@
 		
 		cap_publish(task, handle, kobject);
-
-		*out_handle = handle;
 	}
-	return rc;
+	
+	return handle;
 }
 
Index: kernel/generic/src/ipc/irq.c
===================================================================
--- kernel/generic/src/ipc/irq.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/irq.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -78,5 +78,5 @@
 }
 
-static errno_t ranges_map_and_apply(irq_pio_range_t *ranges, size_t rangecount,
+static int ranges_map_and_apply(irq_pio_range_t *ranges, size_t rangecount,
     irq_cmd_t *cmds, size_t cmdcount)
 {
@@ -164,5 +164,5 @@
  *
  */
-static errno_t code_check(irq_cmd_t *cmds, size_t cmdcount)
+static int code_check(irq_cmd_t *cmds, size_t cmdcount)
 {
 	for (size_t i = 0; i < cmdcount; i++) {
@@ -226,5 +226,5 @@
 	
 	irq_code_t *code = malloc(sizeof(*code), 0);
-	errno_t rc = copy_from_uspace(code, ucode, sizeof(*code));
+	int rc = copy_from_uspace(code, ucode, sizeof(*code));
 	if (rc != EOK)
 		goto error;
@@ -308,11 +308,10 @@
  * @param ucode   Uspace pointer to top-half IRQ code.
  *
- * @param[out] uspace_handle  Uspace pointer to IRQ capability handle
- *
- * @return  Error code.
- *
- */
-errno_t ipc_irq_subscribe(answerbox_t *box, inr_t inr, sysarg_t imethod,
-    irq_code_t *ucode, cap_handle_t *uspace_handle)
+ * @return  IRQ capability handle.
+ * @return  Negative error code.
+ *
+ */
+int ipc_irq_subscribe(answerbox_t *box, inr_t inr, sysarg_t imethod,
+    irq_code_t *ucode)
 {
 	if ((inr < 0) || (inr > last_inr))
@@ -330,15 +329,8 @@
 	 * Allocate and populate the IRQ kernel object.
 	 */
-	cap_handle_t handle;
-	errno_t rc = cap_alloc(TASK, &handle);
-	if (rc != EOK)
-		return rc;
-	
-	rc = copy_to_uspace(uspace_handle, &handle, sizeof(cap_handle_t));
-	if (rc != EOK) {
-		cap_free(TASK, handle);
-		return rc;
-	}
-
+	cap_handle_t handle = cap_alloc(TASK);
+	if (handle < 0)
+		return handle;
+	
 	irq_t *irq = (irq_t *) slab_alloc(irq_cache, FRAME_ATOMIC);
 	if (!irq) {
@@ -379,5 +371,5 @@
 	cap_publish(TASK, handle, kobject);
 	
-	return EOK;
+	return handle;
 }
 
@@ -387,8 +379,8 @@
  * @param handle  IRQ capability handle.
  *
- * @return EOK on success or an error code.
- *
- */
-errno_t ipc_irq_unsubscribe(answerbox_t *box, int handle)
+ * @return EOK on success or a negative error code.
+ *
+ */
+int ipc_irq_unsubscribe(answerbox_t *box, int handle)
 {
 	kobject_t *kobj = cap_unpublish(TASK, handle, KOBJECT_TYPE_IRQ);
Index: kernel/generic/src/ipc/kbox.c
===================================================================
--- kernel/generic/src/ipc/kbox.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/kbox.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -206,9 +206,8 @@
  * cleanup code.
  *
- * @param[out] out_phone  Phone capability handle on success.
- * @return Error code.
- *
- */
-errno_t ipc_connect_kbox(task_id_t taskid, cap_handle_t *out_phone)
+ * @return Phone capability handle on success, or negative error code.
+ *
+ */
+int ipc_connect_kbox(task_id_t taskid)
 {
 	irq_spinlock_lock(&tasks_lock, true);
@@ -232,29 +231,13 @@
 	}
 	
-	if (task->kb.finished) {
+	if (task->kb.finished != false) {
 		mutex_unlock(&task->kb.cleanup_lock);
 		return EINVAL;
 	}
 	
-	/* Create a kbox thread if necessary. */
-	if (task->kb.thread == NULL) {
-		thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task,
-		    THREAD_FLAG_NONE, "kbox");
-		
-		if (!kb_thread) {
-			mutex_unlock(&task->kb.cleanup_lock);
-			return ENOMEM;
-		}
-		
-		task->kb.thread = kb_thread;
-		thread_ready(kb_thread);
-	}
-	
-	/* Allocate a new phone. */
-	cap_handle_t phone_handle;
-	errno_t rc = phone_alloc(TASK, &phone_handle);
-	if (rc != EOK) {
-		mutex_unlock(&task->kb.cleanup_lock);
-		return rc;
+	cap_handle_t phone_handle = phone_alloc(TASK);
+	if (phone_handle < 0) {
+		mutex_unlock(&task->kb.cleanup_lock);
+		return phone_handle;
 	}
 	
@@ -265,7 +248,23 @@
 	(void) ipc_phone_connect(phone_obj->phone, &task->kb.box);
 	
+	if (task->kb.thread != NULL) {
+		mutex_unlock(&task->kb.cleanup_lock);
+		return phone_handle;
+	}
+	
+	/* Create a kbox thread */
+	thread_t *kb_thread = thread_create(kbox_thread_proc, NULL, task,
+	    THREAD_FLAG_NONE, "kbox");
+	if (!kb_thread) {
+		mutex_unlock(&task->kb.cleanup_lock);
+		return ENOMEM;
+	}
+	
+	task->kb.thread = kb_thread;
+	thread_ready(kb_thread);
+	
 	mutex_unlock(&task->kb.cleanup_lock);
-	*out_phone = phone_handle;
-	return EOK;
+	
+	return phone_handle;
 }
 
Index: kernel/generic/src/ipc/ops/conctmeto.c
===================================================================
--- kernel/generic/src/ipc/ops/conctmeto.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/conctmeto.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -40,15 +40,12 @@
 #include <arch.h>
 
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
-	cap_handle_t phone_handle;
-	errno_t rc = phone_alloc(TASK, &phone_handle);
+	cap_handle_t phone_handle = phone_alloc(TASK);
 
-	/* Remember the phone capability or that an error occured. */
-	call->priv = (rc == EOK) ? phone_handle : -1;
-
-	if (rc != EOK) {
-		return rc;
-	}
+	/* Remember the phone capability or the error. */
+	call->priv = phone_handle;
+	if (phone_handle < 0)
+		return phone_handle;
 
 	/* Set arg5 for server */
@@ -61,12 +58,7 @@
 }
 
-static errno_t request_forget(call_t *call)
+static int request_forget(call_t *call)
 {
 	cap_handle_t phone_handle = (cap_handle_t) call->priv;
-
-	if (phone_handle < 0) {
-		return EOK;
-	}
-
 	phone_dealloc(phone_handle);
 	/* Hand over reference from ARG5 to phone->kobject */
@@ -77,5 +69,5 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	/* Hand over reference from ARG5 to phone */
@@ -93,5 +85,5 @@
 }
 
-static errno_t answer_process(call_t *answer)
+static int answer_process(call_t *answer)
 {
 	cap_handle_t phone_handle = (cap_handle_t) answer->priv;
Index: kernel/generic/src/ipc/ops/concttome.c
===================================================================
--- kernel/generic/src/ipc/ops/concttome.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/concttome.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,11 +42,12 @@
 static int request_process(call_t *call, answerbox_t *box)
 {
-	cap_handle_t phone_handle;
-	errno_t rc = phone_alloc(TASK, &phone_handle);
-	IPC_SET_ARG5(call->data, (rc == EOK) ? phone_handle : -1);
-	return 0;
+	cap_handle_t phone_handle = phone_alloc(TASK);
+
+	IPC_SET_ARG5(call->data, phone_handle);
+	
+	return EOK;
 }
 
-static errno_t answer_cleanup(call_t *answer, ipc_data_t *olddata)
+static int answer_cleanup(call_t *answer, ipc_data_t *olddata)
 {
 	cap_handle_t phone_handle = (cap_handle_t) IPC_GET_ARG5(*olddata);
@@ -58,5 +59,5 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	cap_handle_t phone_handle = (cap_handle_t) IPC_GET_ARG5(*olddata);
Index: kernel/generic/src/ipc/ops/dataread.c
===================================================================
--- kernel/generic/src/ipc/ops/dataread.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/dataread.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <config.h>
 
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
 	size_t size = IPC_GET_ARG2(call->data);
@@ -57,5 +57,5 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	assert(!answer->buffer);
@@ -76,5 +76,5 @@
 				
 			answer->buffer = malloc(size, 0);
-			errno_t rc = copy_from_uspace(answer->buffer,
+			int rc = copy_from_uspace(answer->buffer,
 			    (void *) src, size);
 			if (rc) {
@@ -95,10 +95,10 @@
 }
 
-static errno_t answer_process(call_t *answer)
+static int answer_process(call_t *answer)
 {
 	if (answer->buffer) {
 		uintptr_t dst = IPC_GET_ARG1(answer->data);
 		size_t size = IPC_GET_ARG2(answer->data);
-		errno_t rc;
+		int rc;
 
 		rc = copy_to_uspace((void *) dst, answer->buffer, size);
Index: kernel/generic/src/ipc/ops/datawrite.c
===================================================================
--- kernel/generic/src/ipc/ops/datawrite.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/datawrite.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <config.h>
 
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
 	uintptr_t src = IPC_GET_ARG1(call->data);
@@ -57,6 +57,6 @@
 
 	call->buffer = (uint8_t *) malloc(size, 0);
-	errno_t rc = copy_from_uspace(call->buffer, (void *) src, size);
-	if (rc != EOK) {
+	int rc = copy_from_uspace(call->buffer, (void *) src, size);
+	if (rc != 0) {
 		/*
 		 * call->buffer will be cleaned up in ipc_call_free() at the
@@ -69,5 +69,5 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	assert(answer->buffer);
@@ -80,5 +80,5 @@
 			
 		if (size <= max_size) {
-			errno_t rc = copy_to_uspace((void *) dst,
+			int rc = copy_to_uspace((void *) dst,
 			    answer->buffer, size);
 			if (rc)
Index: kernel/generic/src/ipc/ops/debug.c
===================================================================
--- kernel/generic/src/ipc/ops/debug.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/debug.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,10 +44,10 @@
 }
 
-static errno_t answer_process(call_t *answer)
+static int answer_process(call_t *answer)
 {
 	if (answer->buffer) {
 		uintptr_t dst = IPC_GET_ARG1(answer->data);
 		size_t size = IPC_GET_ARG2(answer->data);
-		errno_t rc;
+		int rc;
 
 		rc = copy_to_uspace((void *) dst, answer->buffer, size);
Index: kernel/generic/src/ipc/ops/pagein.c
===================================================================
--- kernel/generic/src/ipc/ops/pagein.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/pagein.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,5 +44,5 @@
 #include <arch.h>
 
-static errno_t pagein_request_preprocess(call_t *call, phone_t *phone)
+static int pagein_request_process(call_t *call, answerbox_t *box)
 {
 	/*
@@ -52,5 +52,5 @@
 	 * wanted to be each other's pager.
 	 */
-	if (TASK->taskid <= phone->callee->task->taskid)
+	if (call->sender->taskid <= TASK->taskid)
 		return ENOTSUP;
 	else
@@ -58,5 +58,5 @@
 }
 
-static errno_t pagein_answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int pagein_answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	/*
@@ -97,7 +97,7 @@
 
 sysipc_ops_t ipc_m_page_in_ops = {
-	.request_preprocess = pagein_request_preprocess,
+	.request_preprocess = null_request_preprocess,
 	.request_forget = null_request_forget,
-	.request_process = null_request_process,
+	.request_process = pagein_request_process,
 	.answer_cleanup = null_answer_cleanup,
 	.answer_preprocess = pagein_answer_preprocess,
Index: kernel/generic/src/ipc/ops/sharein.c
===================================================================
--- kernel/generic/src/ipc/ops/sharein.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/sharein.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <arch.h>
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
 	if (!IPC_GET_RETVAL(answer->data)) {
@@ -49,5 +49,5 @@
 			
 		uintptr_t dst_base = (uintptr_t) -1;
-		errno_t rc = as_area_share(AS, IPC_GET_ARG1(answer->data),
+		int rc = as_area_share(AS, IPC_GET_ARG1(answer->data),
 		    IPC_GET_ARG1(*olddata), as, IPC_GET_ARG2(answer->data),
 		    &dst_base, IPC_GET_ARG3(answer->data));
Index: kernel/generic/src/ipc/ops/shareout.c
===================================================================
--- kernel/generic/src/ipc/ops/shareout.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/shareout.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,5 @@
 #include <arch.h>
 
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
 	size_t size = as_area_get_size(IPC_GET_ARG1(call->data));
@@ -53,7 +53,7 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	if (!IPC_GET_RETVAL(answer->data)) {
Index: kernel/generic/src/ipc/ops/stchngath.c
===================================================================
--- kernel/generic/src/ipc/ops/stchngath.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/ops/stchngath.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -41,5 +41,5 @@
 #include <macros.h>
 
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
 	task_t *other_task_s;
@@ -68,7 +68,7 @@
 }
 
-static errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
+static int answer_preprocess(call_t *answer, ipc_data_t *olddata)
 {
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	if (!IPC_GET_RETVAL(answer->data)) {
Index: kernel/generic/src/ipc/sysipc.c
===================================================================
--- kernel/generic/src/ipc/sysipc.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/sysipc.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -155,10 +155,10 @@
  * @param olddata Saved data of the request.
  *
- * @return Return EOK on success or an error code.
- *
- */
-errno_t answer_preprocess(call_t *answer, ipc_data_t *olddata)
-{
-	errno_t rc = EOK;
+ * @return Return EOK on success or a negative error code.
+ *
+ */
+int answer_preprocess(call_t *answer, ipc_data_t *olddata)
+{
+	int rc = EOK;
 
 	spinlock_lock(&answer->forget_lock);
@@ -194,5 +194,5 @@
 	spinlock_unlock(&answer->forget_lock);
 
-	if ((errno_t) IPC_GET_RETVAL(answer->data) == EHANGUP) {
+	if ((native_t) IPC_GET_RETVAL(answer->data) == EHANGUP) {
 		phone_t *phone = answer->caller_phone;
 		mutex_lock(&phone->lock);
@@ -222,5 +222,5 @@
  *
  */
-static errno_t request_preprocess(call_t *call, phone_t *phone)
+static int request_preprocess(call_t *call, phone_t *phone)
 {
 	call->request_method = IPC_GET_IMETHOD(call->data);
@@ -239,5 +239,5 @@
 static void process_answer(call_t *call)
 {
-	if (((errno_t) IPC_GET_RETVAL(call->data) == EHANGUP) &&
+	if (((native_t) IPC_GET_RETVAL(call->data) == EHANGUP) &&
 	    (call->flags & IPC_CALL_FORWARDED))
 		IPC_SET_RETVAL(call->data, EFORWARD);
@@ -271,5 +271,5 @@
  *
  */
-errno_t ipc_req_internal(cap_handle_t handle, ipc_data_t *data, sysarg_t priv)
+int ipc_req_internal(cap_handle_t handle, ipc_data_t *data, sysarg_t priv)
 {
 	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
@@ -281,5 +281,5 @@
 	memcpy(call->data.args, data->args, sizeof(data->args));
 	
-	errno_t rc = request_preprocess(call, kobj->phone);
+	int rc = request_preprocess(call, kobj->phone);
 	if (!rc) {
 #ifdef CONFIG_UDEBUG
@@ -359,8 +359,8 @@
  *
  * @return EOK on success.
- * @return An error code on error.
- *
- */
-sys_errno_t sys_ipc_call_async_fast(sysarg_t handle, sysarg_t imethod,
+ * @return Negative error code on error.
+ *
+ */
+sysarg_t sys_ipc_call_async_fast(sysarg_t handle, sysarg_t imethod,
     sysarg_t arg1, sysarg_t arg2, sysarg_t arg3, sysarg_t label)
 {
@@ -389,5 +389,5 @@
 	call->data.label = label;
 	
-	errno_t res = request_preprocess(call, kobj->phone);
+	int res = request_preprocess(call, kobj->phone);
 	
 	if (!res)
@@ -409,5 +409,5 @@
  *
  */
-sys_errno_t sys_ipc_call_async_slow(sysarg_t handle, ipc_data_t *data,
+sysarg_t sys_ipc_call_async_slow(sysarg_t handle, ipc_data_t *data,
     sysarg_t label)
 {
@@ -422,10 +422,10 @@
 
 	call_t *call = ipc_call_alloc(0);
-	errno_t rc = copy_from_uspace(&call->data.args, &data->args,
+	int rc = copy_from_uspace(&call->data.args, &data->args,
 	    sizeof(call->data.args));
-	if (rc != EOK) {
+	if (rc != 0) {
 		kobject_put(call->kobject);
 		kobject_put(kobj);
-		return (sys_errno_t) rc;
+		return (sysarg_t) rc;
 	}
 
@@ -433,5 +433,5 @@
 	call->data.label = label;
 	
-	errno_t res = request_preprocess(call, kobj->phone);
+	int res = request_preprocess(call, kobj->phone);
 	
 	if (!res)
@@ -466,5 +466,5 @@
  *
  */
-static sys_errno_t sys_ipc_forward_common(sysarg_t chandle, sysarg_t phandle,
+static sysarg_t sys_ipc_forward_common(sysarg_t chandle, sysarg_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, sysarg_t arg3,
     sysarg_t arg4, sysarg_t arg5, unsigned int mode, bool slow)
@@ -482,5 +482,5 @@
 	
 	bool after_forward = false;
-	errno_t rc;
+	int rc;
 
 	kobject_t *pkobj = kobject_get(TASK, phandle, KOBJECT_TYPE_PHONE);
@@ -577,5 +577,5 @@
  *
  */
-sys_errno_t sys_ipc_forward_fast(sysarg_t chandle, sysarg_t phandle,
+sysarg_t sys_ipc_forward_fast(sysarg_t chandle, sysarg_t phandle,
     sysarg_t imethod, sysarg_t arg1, sysarg_t arg2, unsigned int mode)
 {
@@ -601,12 +601,12 @@
  *
  */
-sys_errno_t sys_ipc_forward_slow(sysarg_t chandle, sysarg_t phandle,
+sysarg_t sys_ipc_forward_slow(sysarg_t chandle, sysarg_t phandle,
     ipc_data_t *data, unsigned int mode)
 {
 	ipc_data_t newdata;
-	errno_t rc = copy_from_uspace(&newdata.args, &data->args,
+	int rc = copy_from_uspace(&newdata.args, &data->args,
 	    sizeof(newdata.args));
-	if (rc != EOK)
-		return (sys_errno_t) rc;
+	if (rc != 0)
+		return (sysarg_t) rc;
 	
 	return sys_ipc_forward_common(chandle, phandle,
@@ -631,5 +631,5 @@
  *
  */
-sys_errno_t sys_ipc_answer_fast(sysarg_t chandle, sysarg_t retval, sysarg_t arg1,
+sysarg_t sys_ipc_answer_fast(sysarg_t chandle, sysarg_t retval, sysarg_t arg1,
     sysarg_t arg2, sysarg_t arg3, sysarg_t arg4)
 {
@@ -660,5 +660,5 @@
 	 */
 	IPC_SET_ARG5(call->data, 0);
-	errno_t rc = answer_preprocess(call, saved ? &saved_data : NULL);
+	int rc = answer_preprocess(call, saved ? &saved_data : NULL);
 	
 	ipc_answer(&TASK->answerbox, call);
@@ -678,5 +678,5 @@
  *
  */
-sys_errno_t sys_ipc_answer_slow(sysarg_t chandle, ipc_data_t *data)
+sysarg_t sys_ipc_answer_slow(sysarg_t chandle, ipc_data_t *data)
 {
 	kobject_t *kobj = cap_unpublish(TASK, chandle, KOBJECT_TYPE_CALL);
@@ -695,7 +695,7 @@
 		saved = false;
 	
-	errno_t rc = copy_from_uspace(&call->data.args, &data->args, 
+	int rc = copy_from_uspace(&call->data.args, &data->args, 
 	    sizeof(call->data.args));
-	if (rc != EOK) {
+	if (rc != 0) {
 		/*
 		 * Republish the capability so that the call does not get lost.
@@ -722,5 +722,5 @@
  *
  */
-sys_errno_t sys_ipc_hangup(sysarg_t handle)
+sysarg_t sys_ipc_hangup(sysarg_t handle)
 {
 	kobject_t *kobj = kobject_get(TASK, handle, KOBJECT_TYPE_PHONE);
@@ -728,7 +728,11 @@
 		return ENOENT;
 	
-	errno_t rc = ipc_phone_hangup(kobj->phone);
+	if (ipc_phone_hangup(kobj->phone)) {
+		kobject_put(kobj);
+		return -1;
+	}
+	
 	kobject_put(kobj);
-	return rc;
+	return 0;
 }
 
@@ -740,7 +744,9 @@
  *                 for explanation.
  *
- * @return An error code on error.
- */
-sys_errno_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec,
+ * @return Capability handle of the received request.
+ * @return CAP_NIL for answers, notifications and when there is no call.
+ * @return Negative error code on error.
+ */
+sysarg_t sys_ipc_wait_for_call(ipc_data_t *calldata, uint32_t usec,
     unsigned int flags)
 {
@@ -761,21 +767,18 @@
 
 	if (!call) {
-		ipc_data_t data = {};
-		data.cap_handle = CAP_NIL;
-		STRUCT_TO_USPACE(calldata, &data);
-		return EOK;
-	}
-	
-	call->data.flags = call->flags;
+		STRUCT_TO_USPACE(calldata, &(ipc_data_t){});
+		return CAP_NIL;
+	}
+	
 	if (call->flags & IPC_CALL_NOTIF) {
 		/* Set in_phone_hash to the interrupt counter */
 		call->data.phone = (void *) call->priv;
 		
-		call->data.cap_handle = CAP_NIL;
+		call->data.flags = IPC_CALL_NOTIF;
 
 		STRUCT_TO_USPACE(calldata, &call->data);
 		kobject_put(call->kobject);
 		
-		return EOK;
+		return CAP_NIL;
 	}
 	
@@ -788,10 +791,10 @@
 		}
 
-		call->data.cap_handle = CAP_NIL;
+		call->data.flags = IPC_CALL_ANSWERED;
 		
 		STRUCT_TO_USPACE(calldata, &call->data);
 		kobject_put(call->kobject);
 		
-		return EOK;
+		return CAP_NIL;
 	}
 	
@@ -799,12 +802,11 @@
 		goto restart;
 	
-	cap_handle_t handle;
-	errno_t rc = cap_alloc(TASK, &handle);
-	if (rc != EOK) {
+	int rc;
+	cap_handle_t handle = cap_alloc(TASK);
+	if (handle < 0) {
+		rc = handle;
 		goto error;
 	}
 	
-	call->data.cap_handle = handle;
-
 	/*
 	 * Include phone hash of the caller in the request, copy the whole
@@ -817,5 +819,5 @@
 	kobject_add_ref(call->kobject);
 	cap_publish(TASK, handle, call->kobject);
-	return EOK;
+	return handle;
 
 error:
@@ -825,6 +827,5 @@
 	/*
 	 * The callee will not receive this call and no one else has a chance to
-	 * answer it. Set the IPC_CALL_AUTO_REPLY flag and return the EPARTY
-	 * error code.
+	 * answer it. Reply with the EPARTY error code.
 	 */
 	ipc_data_t saved_data;
@@ -839,5 +840,4 @@
 	IPC_SET_RETVAL(call->data, EPARTY);
 	(void) answer_preprocess(call, saved ? &saved_data : NULL);
-	call->flags |= IPC_CALL_AUTO_REPLY;
 	ipc_answer(&TASK->answerbox, call);
 
@@ -848,5 +848,5 @@
  *
  */
-sys_errno_t sys_ipc_poke(void)
+sysarg_t sys_ipc_poke(void)
 {
 	waitq_unsleep(&TASK->answerbox.wq);
@@ -860,17 +860,15 @@
  * @param ucode   Uspace pointer to the top-half pseudocode.
  *
- * @param[out] uspace_handle  Uspace pointer to IRQ kernel object capability
- *
+ * @return IRQ kernel object capability
  * @return EPERM
  * @return Error code returned by ipc_irq_subscribe().
  *
  */
-sys_errno_t sys_ipc_irq_subscribe(inr_t inr, sysarg_t imethod, irq_code_t *ucode,
-	cap_handle_t *uspace_handle)
+sysarg_t sys_ipc_irq_subscribe(inr_t inr, sysarg_t imethod, irq_code_t *ucode)
 {
 	if (!(perm_get(TASK) & PERM_IRQ_REG))
 		return EPERM;
 	
-	return ipc_irq_subscribe(&TASK->answerbox, inr, imethod, ucode, uspace_handle);
+	return ipc_irq_subscribe(&TASK->answerbox, inr, imethod, ucode);
 }
 
@@ -883,5 +881,5 @@
  *
  */
-sys_errno_t sys_ipc_irq_unsubscribe(sysarg_t cap)
+sysarg_t sys_ipc_irq_unsubscribe(sysarg_t cap)
 {
 	if (!(perm_get(TASK) & PERM_IRQ_REG))
@@ -893,34 +891,45 @@
 }
 
-/** Syscall connect to a task by ID
- *
- * @return Error code.
- *
- */
-sys_errno_t sys_ipc_connect_kbox(task_id_t *uspace_taskid, cap_handle_t *uspace_phone)
+#ifdef __32_BITS__
+
+/** Syscall connect to a task by ID (32 bits)
+ *
+ * @return Phone id on success, or negative error code.
+ *
+ */
+sysarg_t sys_ipc_connect_kbox(sysarg64_t *uspace_taskid)
 {
 #ifdef CONFIG_UDEBUG
-	task_id_t taskid;
-	cap_handle_t phone;
-	
-	errno_t rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(task_id_t));
-	if (rc == EOK) {
-		rc = ipc_connect_kbox((task_id_t) taskid, &phone);
-	}
-	
-	if (rc == EOK) {
-		rc = copy_to_uspace(uspace_phone, &phone, sizeof(cap_handle_t));
-		if (rc != EOK) {
-			// Clean up the phone on failure.
-			sys_ipc_hangup(phone);
-		}
-	}
-	
-	return (sys_errno_t) rc;
+	sysarg64_t taskid;
+	int rc = copy_from_uspace(&taskid, uspace_taskid, sizeof(sysarg64_t));
+	if (rc != 0)
+		return (sysarg_t) rc;
+	
+	return ipc_connect_kbox((task_id_t) taskid);
 #else
-	return (sys_errno_t) ENOTSUP;
+	return (sysarg_t) ENOTSUP;
 #endif
 }
 
+#endif  /* __32_BITS__ */
+
+#ifdef __64_BITS__
+
+/** Syscall connect to a task by ID (64 bits)
+ *
+ * @return Phone id on success, or negative error code.
+ *
+ */
+sysarg_t sys_ipc_connect_kbox(sysarg_t taskid)
+{
+#ifdef CONFIG_UDEBUG
+	return ipc_connect_kbox((task_id_t) taskid);
+#else
+	return (sysarg_t) ENOTSUP;
+#endif
+}
+
+#endif  /* __64_BITS__ */
+
 /** @}
  */
Index: kernel/generic/src/ipc/sysipc_ops.c
===================================================================
--- kernel/generic/src/ipc/sysipc_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ kernel/generic/src/ipc/sysipc_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -69,10 +69,10 @@
 };
 
-errno_t null_request_preprocess(call_t *call, phone_t *phone)
+int null_request_preprocess(call_t *call, phone_t *phone)
 {
 	return EOK;
 }
 
-errno_t null_request_forget(call_t *call)
+int null_request_forget(call_t *call)
 {
 	return EOK;
@@ -81,18 +81,18 @@
 int null_request_process(call_t *call, answerbox_t *box)
 {
-	return 0;
+	return EOK;
 }
 
-errno_t null_answer_cleanup(call_t *call, ipc_data_t *data)
+int null_answer_cleanup(call_t *call, ipc_data_t *data)
 {
 	return EOK;
 }
 
-errno_t null_answer_preprocess(call_t *call, ipc_data_t *data)
+int null_answer_preprocess(call_t *call, ipc_data_t *data)
 {
 	return EOK;
 }
 
-errno_t null_answer_process(call_t *call)
+int null_answer_process(call_t *call)
 {
 	return EOK;
